searchNodes=[{"ref":"PlugBodyDigest.html","title":"PlugBodyDigest","type":"module","doc":"Plug to verify the request body against the digest value sent in the HTTP &#39;Digest&#39; header, as defined in RFC3230, section 4.3.2. Supported digests are &quot;sha-512&quot;, &quot;sha-256&quot; and &quot;sha&quot;. Options :on_success - an optional callback for updating the Plug.Conn state upon success; possible values include: nil (the default) - do nothing {m, f, a} - call the function identified by the atom f in module m; the function receives the current Plug.Conn struct along with any additional parameters in the list a, and is expected to return the updated Plug.Conn struct; see the example below :on_failure - an optional callback for updating the Plug.Conn state upon failure; possible values include: {PlugBodyDigest, :failure, []} (the default) - halt the connection with an appropriate response; see failure/3 below {PlugBodyDigest, :optional, []} - make the &#39;Digest&#39; header optional; see optional/3 below {m, f, a} - call the function identified by the atom f in module m; the function receives the current Plug.Conn struct, the error reason (see error_reason/0) and the algorithm list (a string, for possible use in a &#39;Want-Digest&#39; response header) along with any additional parameters in the list a, and is expected to return the updated Plug.Conn struct nil - do nothing Example # Update the Plug.Parsers configuration, adding the `:body_reader` # option: plug Plug.Parsers, parsers: [:urlencoded, :json], body_reader: {PlugBodyDigest, :digest_body_reader, []}, json_decoder: Jason # Invoke PlugBodyDigest after Plug.Parsers plug PlugBodyDigest, on_success: {Plug.Conn, :assign, [:valid_digest, true]}, on_failure: {PlugBodyDigest, :optional, []}"},{"ref":"PlugBodyDigest.html#digest_body_reader/3","title":"PlugBodyDigest.digest_body_reader/3","type":"function","doc":"Custom request body reader for Plug.Parsers, updating the digest value(s) while the request body is being read. Add or update Plug.Parsers (e.g. in the application&#39;s Phoenix endpoint) with the :body_reader option: plug Plug.Parsers, parsers: [:urlencoded, :json], body_reader: {PlugBodyDigest, :digest_body_reader, []}, json_decoder: Jason Only works for parsers that respect the :body_reader option, including Plug.Parsers.URLENCODED and Plug.Parsers.JSON. Not supported are Plug.Parsers.MULTIPART and content types that are ignored by Plug.Parsers through the :pass option."},{"ref":"PlugBodyDigest.html#failure/3","title":"PlugBodyDigest.failure/3","type":"function","doc":"The default failure function. It logs an error, returns a 500 &#39;Server Error&#39; response and halts the connection in the following scenarios: If the request body was not read, because the request&#39;s &#39;Content-Type&#39; is not handled by Plug.Parsers; see digest_body_reader/3 If the digest function invocation failed for the selected algorithm Otherwise logs the failure, returns a 403 &#39;Forbidden&#39; response with a &#39;Want-Digest&#39; response header listing the supported algorithms, and halts the connection."},{"ref":"PlugBodyDigest.html#optional/3","title":"PlugBodyDigest.optional/3","type":"function","doc":"An alternative failure handler function, allowing requests without a &#39;Digest&#39; request header. All other errors are handled as described for failure/3."},{"ref":"PlugBodyDigest.html#t:error_reason/0","title":"PlugBodyDigest.error_reason/0","type":"type","doc":"Error reasons, passed to the failure callback. Server errors: :body_not_read - the request body was not read, because the request&#39;s &#39;Content-Type&#39; is not handled by Plug.Parsers; see digest_body_reader/3 :multipart - the request contained a multipart content-type, which is not supported by PlugBodyDigest; see digest_body_reader/3 :bad_algorithm - the digest function invocation failed for the selected algorithm; verify that the :crypto application was started and that it supports the necessary algorithms Client errors: :no_digest_header - no &#39;Digest&#39; header was included in the request :algorithm_mismatch - none of the supported digest algorithms was included in the &#39;Digest&#39; request header :malformed_digest_value - the digest value in the &#39;Digest&#39; request header could not be decoded :digest_mismatch - the calculated digest value for the request body does not match the expected value specified in the &#39;Digest&#39; request header"},{"ref":"readme.html","title":"PlugBodyDigest","type":"extras","doc":"PlugBodyDigest Plug to verify the request body against the digest value sent in the HTTP &#39;Digest&#39; header, as defined in RFC3230, section 4.3.2. Typically used in combination with an HTTP request signature covering the &#39;Digest&#39; header value, to protect the integrity of the complete request. By default halts the request in case of failure, for example if no Digest header was sent or the request body did not match the specified digest value. Failure and success handling can be customized using the configuration options documented in the PlugBodyDigest module. Please note: this package supports parsers that respect the :body_reader option of Plug.Parsers, including Plug.Parsers.URLENCODED and Plug.Parsers.JSON. Not supported are Plug.Parsers.MULTIPART and content types that are ignored by Plug.Parsers through the :pass option. Development and public release of this package were made possible by Bluecode."},{"ref":"readme.html#example","title":"PlugBodyDigest - Example","type":"extras","doc":"Update the Plug.Parsers configuration, e.g. in application&#39;s Phoenix Endpoint, to use the PlugBodyDigest.digest_body_reader/2,3 function for reading the request body: plug Plug.Parsers, parsers: [:urlencoded, :json], body_reader: {PlugBodyDigest, :digest_body_reader, []}, json_decoder: Jason Add PlugBodyDigest, somewhere after Plug.Parsers, for example in a Phoenix Router pipeline: pipeline :api do plug :accepts, [&quot;json&quot;] plug PlugBodyDigest end Or in a Phoenix Controller: defmodule MyAppWeb.APIController do use MyAppWeb, :controller # Failure handling options or PlugBodyDigest @mandatory [] @optional [on_failure: {PlugBodyDigest, :optional, []}] # Digest header is required for POST and PUT, optional otherwise plug PlugBodyDigest, @mandatory when action in [:create, :update] plug PlugBodyDigest, @optional when action in [:index, :show, :delete] # ... end"},{"ref":"readme.html#installation","title":"PlugBodyDigest - Installation","type":"extras","doc":"Add plug_body_digest to your list of dependencies in mix.exs: def deps do [ {:plug_body_digest, &quot;~&gt; 0.5.0&quot;} ] end Documentation can be found at https://hexdocs.pm/plug_body_digest."},{"ref":"readme.html#license","title":"PlugBodyDigest - License","type":"extras","doc":"Copyright (c) 2019, Bram Verburg All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."}]